<template>
  <div class="content">
    <vue-confirm-dialog></vue-confirm-dialog>
    <h3 class="h2" style="margin-top: 70px;">
      <i class="fa fa-book" style="padding-right: 10px; font-size: 40px"></i
      ><strong>Daftar Booking Prioritas</strong>
    </h3>
    <div
      class="main"
      style="border-radius: 20px; margin-top: 30px; min-height: 400px; box-shadow: 5px 5px #c5c5c5; padding-bottom: 70px"
    >
      <div
        class="main main-raised"
        style="border-radius: 50px; float:right; top: 45px; right:20px; height: 0px"
      >
        <p
          class="md-list-item-router md-layout gradient2"
          style="border-radius: 50px; box-shadow: 5px 5px #c5c5c5"
        >
          <md-button
            @click="myFunction2()"
            class="md-button1 md-simple"
            style="height: 40px; width: 250px;"
          >
            <span
              style="color: white; font-size: 14px; text-transform: capitalize"
            >
              Tambah Booking MK KOTA
            </span>
          </md-button>
        </p>
      </div>
      <md-table
        v-model="bookingPriorityList"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 50px 15px 0px 30px; border-radius: 20px;"
        md-fixed-header
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="md-toolbar-section-start">
            <md-field style="padding: 5px 0px 0px 15px; max-width: 300px;">
              <label>Pilih Periode...</label>
              <md-select
                name="periode.id"
                id="periode.id"
                v-model="selectedPeriode2"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(periode, key) in periodeList"
                  :key="key"
                  :value="periode.id"
                  style="width:100%; left: 10px;"
                >
                  <div
                    v-if="periode.semester == '01' || periode.semester == '1'"
                  >
                    {{ periode.tahun }} (Ganjil)
                  </div>
                  <div
                    v-if="periode.semester == '02' || periode.semester == '2'"
                  >
                    {{ periode.tahun }} (Genap)
                  </div>
                </md-option>
              </md-select>
            </md-field>
            <md-field
              style="margin-left: 30px; padding: 5px 0px 0px 15px; max-width: 300px;"
            >
              <label>Pilih Prodi...</label>
              <md-select
                name="prodi.id"
                id="prodi.id"
                v-model="selectedProdi"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(prodi, key) in prodiList"
                  :key="key"
                  :value="prodi.id"
                  style="width:100%; left: 10px;"
                >
                  {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                </md-option>
              </md-select>
            </md-field>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <md-table-cell md-label="Kode" md-sort-by="mata_kuliah.kode_mk">
            {{ item.mata_kuliah.kode_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Nama Mata Kuliah"
            md-sort-by="mata_kuliah.nama_mk"
          >
            {{ item.mata_kuliah.nama_mk }}
          </md-table-cell>
          <!-- <md-table-cell
            md-label="Prodi"
            md-sort-by="users.prodi.singkatan_prodi"
          >
            {{ item.users.prodi.singkatan_prodi }}
          </md-table-cell> -->
          <md-table-cell md-label="Nama Mahasiswa" md-sort-by="peserta">
            {{ item.peserta }}
          </md-table-cell>
          <md-table-cell>
            <router-link
              :to="{
                name: 'booking-priority-update-admin',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
              "
                ><md-tooltip md-direction="bottom"
                  >Update Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell>
            <md-button
              type="submit"
              class="md-simple md-danger"
              style="height: 20px;"
              @click="onDelete(item.id)"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Booking Priority</md-tooltip
                ></i
              >
            </md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>
    <md-progress-bar md-mode="indeterminate" v-if="sending" />

    <md-snackbar :md-active.sync="userSaved"
      >Proses menghapus berhasil</md-snackbar
    >
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
// import moment from "moment";

// const toLower = text => {
//   return text.toString().toLowerCase();
// };

export default {
  components: {},
  bodyClass: "login-page",
  //   data() {},
  data: () => ({
    total: "",
    classicModal: false,
    searched: [],
    selectedPeriode: "",
    selectedProdi: ""
  }),
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("laporan", ["kaprodiList", "laporanList"]),
    ...mapState("bookingPriority", ["bookedList", "bookingPriorityList"]),
    ...mapState("periode", ["periodeData", "periodeList"]),
    ...mapState("prodi", ["prodiData", "prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("laporan", ["getLaporanList", "kaprodi"]),
    ...mapActions("bookingPriority", [
      "getBookingPriorityList",
      "booked",
      "deleteBookingPriority"
    ]),
    ...mapActions("periode", ["getPeriode", "getPeriodeList"]),
    ...mapActions("prodi", ["getProdi", "getProdiList"]),
    async onFetchData() {
      await this.getPeriodeList();
      await this.getLaporanList();
      await this.getBookingPriorityList();
      await this.kaprodi({
        periode_id: this.selectedPeriode
      });
      await this.booked({
        periode_id: this.selectedPeriode2
      });
      await this.getProdiList();
    },
    onDelete(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data Booking Priority?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deleteBookingPriority({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    myFunction: function() {
      window.open(
        "#/dashboard/mata-kuliah-kaprodi-create",
        "",
        "width=440,height=600"
      );
    },
    myFunction2: function() {
      window.open(
        "#/dashboard/booking-priority-create",
        "",
        "width=450,height=430"
      );
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    },
    searchOnTable() {
      this.getLaporanList({
        periode_id: this.selectedPeriode
      });
      this.kaprodi({
        periode_id: this.selectedPeriode
      });
      this.getBookingPriorityList({
        periode_id: this.selectedPeriode,
        prodi_id: this.selectedProdi
      });
      this.booked({
        periode_id: this.selectedPeriode2
      });
    },
    classicModalHide() {
      this.classicModal = false;
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  }
  // created() {
  //   this.searched = this.laporanList;
  // }
};
</script>

<style lang="scss" scoped></style>

<style lang="css"></style>
